# -*- coding: utf-8 -*-
# pylint: disable=bad-whitespace
# flake8: noqa
"""
    JS Invoke Lib – Project automation library for invoke.
    Copyright ©  2017 Justin Stout <justin@jstout.us>
"""
from __future__ import absolute_import, print_function

import os
from os.path import join as join_path

from invoke import run
from invoke import task

from js_invoke_lib.core import get_project_info

@task(help={'module': "name of module to test (ex my_module or my_module.my_class) (default = all)"})
def pylint(module=None):
    """
    Run pylint code quality tests.
    """
    project_info = get_project_info()

    try:
        os.makedirs('/vagrant/reports/pylint')

    except OSError:
        """Directory already exists"""
        pass

    report_path = '/vagrant/reports/pylint/pylint.txt'

    base_path = join_path(
        '/vagrant',
        'src',
        project_info['pkg_name'],
        project_info['pkg_name']
        )

    if module:
        base_path = join_path(
            base_path,
            module.replace('.', '/')
            )

    if os.path.isfile(base_path + '.py'):
        base_path += '.py'

    cmd = "pylint --rcfile=/vagrant/project.d/pylint.cfg {} 2>&1 > {}".format(base_path, report_path)
    run(cmd)
